###############################################################################
##                                                                           ##
## This file is part of ModelBlocks. Copyright 2009, ModelBlocks developers. ##
##                                                                           ##
##    ModelBlocks is free software: you can redistribute it and/or modify    ##
##    it under the terms of the GNU General Public License as published by   ##
##    the Free Software Foundation, either version 3 of the License, or      ##
##    (at your option) any later version.                                    ##
##                                                                           ##
##    ModelBlocks is distributed in the hope that it will be useful,         ##
##    but WITHOUT ANY WARRANTY; without even the implied warranty of         ##
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          ##
##    GNU General Public License for more details.                           ##
##                                                                           ##
##    You should have received a copy of the GNU General Public License      ##
##    along with ModelBlocks.  If not, see <http://www.gnu.org/licenses/>.   ##
##                                                                           ##
###############################################################################


# cat wsj_0001.trees | perl scripts/treesed.pl

## for each tree...
while ( <> ) {

  ## translate to parens...
  s/\[/\(/g;
  s/\]/\)/g;

  ## for each constituent...
  while ( $_ =~ /\([^\(\)]*\)/ ) {

    ## convert outer parens to braces...
    $_ =~ s/\(([^\(\)]*)\)/{\1}/;

    ########## ADD SED RULES HERE: apply rules to angles (children) within braces (consituent)...
    ##print stderr "in:   $_\n";
    s/{([^ ]*) *<\1[^ ]* ([^>]*)> *(<\. .*>) *}/{\1 \2 \3}/; # undo grab trailing period
    #s/{(VB|NN|JJ|RB|BES|TO|MD)[^ ]* *(<.*)}/\2/;
    s/(\(.*){(VB|NN|JJ|RB|BES|TO|MD)[^ ]* *(<.*)}/\1\3/;
    s/{([^ ]*\_[^ ]*) *(<.*)}/\2/;
    s/{([^ ]*\*[^ ]*) *(<.*)}/\2/;
    s/{WHSBAR([^ ]*) +(<WH.*) +(<S.*)}/{SBAR\1 \2 \3}/;
    s/{Unk +(<.*)}/\1/;
    ##print stderr "out:  $_\n";
    ##########

    ## convert inner angles (if any) to bracks...
    while ($_ =~ /{[^{}]*</) {
      $_ =~ s/({[^{}]*)<([^<>]*)>/\1\[\2\]/;
    }

    ## convert outer braces to angles...
    $_ =~ s/{(.*)}/<\1>/;
  }

  ## finish up...
  $_ =~ s/</[/;
  $_ =~ s/>/]/;

  ## translate to parens again...
  $_ =~ s/\[/\(/g;
  $_ =~ s/\]/\)/g;

  print $_;
}

